# This file was generated by liblab | https://liblab.com/

from typing import Awaitable, Union, List
from .utils.to_async import to_async
from ..properties import PropertiesService
from ...models.utils.sentinel import SENTINEL
from ...models import Property


class PropertiesServiceAsync(PropertiesService):
    """
    Async Wrapper for PropertiesServiceAsync
    """

    def new(
        self, init: Union[str, None] = SENTINEL, build: Union[str, None] = SENTINEL
    ) -> Awaitable[str]:
        return to_async(super().new)(init, build)

    def get(self, name: str, build: Union[str, None] = SENTINEL) -> Awaitable[str]:
        return to_async(super().get)(name, build)

    def set(
        self,
        name: str,
        value: Union[str, None] = SENTINEL,
        build: Union[str, None] = SENTINEL,
    ) -> Awaitable[any]:
        return to_async(super().set)(name, value, build)

    def add(
        self,
        name: str,
        value: Union[str, None] = SENTINEL,
        build: Union[str, None] = SENTINEL,
    ) -> Awaitable[any]:
        return to_async(super().add)(name, value, build)

    def all(
        self, name: Union[str, None] = SENTINEL, build: Union[str, None] = SENTINEL
    ) -> Awaitable[List[Property]]:
        return to_async(super().all)(name, build)

    def update(
        self, request_body: List[Property], build: Union[str, None] = SENTINEL
    ) -> Awaitable[any]:
        return to_async(super().update)(request_body, build)

    def remove(
        self,
        name: Union[str, None] = SENTINEL,
        value: Union[str, None] = SENTINEL,
        build: Union[str, None] = SENTINEL,
    ) -> Awaitable[any]:
        return to_async(super().remove)(name, value, build)

    def display(
        self,
        name: Union[str, None] = SENTINEL,
        build: Union[str, None] = SENTINEL,
        format: Union[str, None] = SENTINEL,
    ) -> Awaitable[any]:
        return to_async(super().display)(name, build, format)
